
/////////////////////////////////////////////
// Envoyer vers l'appareil 2704
int TPG300::send_rs232_char(char *la_commande, int nb_octets)
{
  int valeur_retour = 0; // par defaut, on met a 0

  if(port == NULL)
  {
    valeur_retour = -1; // Il y a un probleme
    return valeur_retour;        
  }

  int i = port->write(la_commande, nb_octets);

  port->flush();

  if(i != nb_octets)
    valeur_retour = -1; // il y a un probleme

  return valeur_retour; // 0 = tout va bien et -1 = probleme
}


/////////////////////////////////////////////
// Recevoir de l'appareil 2704
void TPG300::receive_rs232_char(char *tableau, int nb_octets)
{

  if(port == NULL)
  {
    return ;
  }


  for(int xyz = 0 ; xyz < 20; xyz++)
  {
    // on regarde s'il y a quelque chose a recuperer
    if( port->bytesAvailable() == 0 && port->size() == 0 && port->atEnd() == 0)
    {
      // on laise un delai pour voir si on ne recoit vraiment rien
       Sleep(15); // 10 ms d'attente
    }
    else
      break;
  }

  if( port->bytesAvailable() == 0 && port->size() == 0 && port->atEnd() == 0) 
  {
    return ; // on quitte s'il n'y a rien a recuperer
  }

  if( port->bytesAvailable() < nb_octets ) 
  {
    // on laise un delai d'attente
    Sleep(20); // 15 ms d'attente
  }

  // lecture d'une ligne
  int i = port->readLine ( tableau, 200);  
  if( i > 0) // c'est bon
    tableau[i] = '\0'; // on ferme le texte
  else // pas bon
  {
    return;
  }

  return; 
}


/////////////////////////////////////////////
// Recevoir rapidement de l'appareil 2704
void TPG300::receive_rs232_rapide(void)
{

  if(port == NULL)
  {
    return ;
  }

  // on regarde s'il y a quelque chose a recuperer
  if( port->bytesAvailable() == 0 && port->size() == 0 && port->atEnd() == 0) 
  {
    return ; // on quitte s'il n'y a rien a recuperer
  }

  // lecture d'une ligne
  char tableau[255];
  port->readLine ( tableau, 200);  

  return; 
}


